// Triang2a.cpp (C) 2006 adolfo@di-mare.com

/** \file  Triang2a.cpp
    \brief Ejemplo de una funcin que determina el tipo de tringulo.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2006
*/

#include <bool.h>

/** Retorna una cdigo numrico que indica si el tringulo es:
    - 1 ==> Equiltero
    - 2 ==> Escaleno
    - 3 ==> Issceles
    - 0 ==> No es tringulo
*/
int Tipo_Triangulo( int A, int B, int C ) {

    bool es_triangulo = true;

    es_triangulo = es_triangulo && ( A > 0 ); // Los lados deben ser
    es_triangulo = es_triangulo && ( B > 0 ); // un nmero positivo
    es_triangulo = es_triangulo && ( C > 0 );

    es_triangulo = es_triangulo && ( A+B > C ); // 2 lados juntos siempre
    es_triangulo = es_triangulo && ( B+C > A ); // son ms largos que el
    es_triangulo = es_triangulo && ( C+A > B ); // otro lado


    if ( ! es_triangulo ) {
        return 0; // ==> No es tringulo
    }

    if ( (A==B) && (B==C) ) {
        return 1; // ==> Equiltero
    }

    if ( (A==B) || (B==C) || (C==A) ) {
        return 3; // ==> Issceles
    }
    return 2; // ==> Escaleno
}


#include <iostream.h>

/// Procedimiento principal de entrada al programa.
int main() {
    int I, J, K;
    cout << endl << endl << "Sale con el nmero de Guillermo Compuertas";
    I = 0;
    while ( I != 666 ) {
        cout << endl << "Deme los lados de su tringulo: ";
        cin >> I >> J >> K;
        switch (  Tipo_Triangulo( I,J,K ) ) {
            case 1: cout << "Equiltero";      break;
            case 2: cout << "Escaleno";        break;
            case 3: cout << "Issceles";       break;
            case 0: cout << "No es tringulo"; break;
            default: cout << "Error en Tipo_Triangulo()";
        }
    }
    return 0; // cdigo de retorno al sistema operativo.
}

// EOF: Triang2a.cpp