// Triang2b.cpp (C) 2006 adolfo@di-mare.com

/** \file  Triang2b.cpp
    \brief Ejemplo de una funcin que determina el tipo de tringulo.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2006
*/

#include <bool.h>

enum TRIANGULO { NO_TRIANGULO=0, EQUILATERO, ISOSCELES, ESCALENO };

/** Retorna una cdigo numrico que indica si el tringulo es:
    - EQUILATERO   ==> Equiltero
    - ISOSCELES    ==> Issceles
    - ESCALENO     ==> Escaleno
    - NO_TRIANGULO ==> No es tringulo
*/
int Tipo_Triangulo( int A, int B, int C ) {

    bool es_triangulo = true;

    es_triangulo = es_triangulo && ( A > 0 ); // Los lados deben ser
    es_triangulo = es_triangulo && ( B > 0 ); // un nmero positivo
    es_triangulo = es_triangulo && ( C > 0 );

    es_triangulo = es_triangulo && ( A+B > C ); // 2 lados juntos siempre
    es_triangulo = es_triangulo && ( B+C > A ); // son ms largos que el
    es_triangulo = es_triangulo && ( C+A > B ); // otro lado

    if ( ! es_triangulo ) {
        return NO_TRIANGULO; // ==> No es tringulo
    }

    if ( (A==B) && (B==C) ) {
        return EQUILATERO; // ==> Equiltero
    }

    if ( (A==B) || (B==C) || (C==A) ) {
        return ISOSCELES; // ==> Issceles
    }
    return ESCALENO; // ==> Escaleno
}


#include <iostream.h>

/// Procedimiento principal de entrada al programa.
int main() {
    int I, J, K;
    cout << endl << endl << "Sale con el nmero de Guillermo Compuertas";
    I = 0;
    while ( I != 666 ) {
        cout << endl << "Deme los lados de su tringulo: ";
        cin >> I >> J >> K;
        switch (  Tipo_Triangulo( I,J,K ) ) {
            case EQUILATERO:   cout << "Equiltero";      break;
            case ESCALENO:     cout << "Escaleno";        break;
            case ISOSCELES:    cout << "Issceles";       break;
            case NO_TRIANGULO: cout << "No es tringulo"; break;
            default: cout << "Error en Tipo_Triangulo()";
        }
    }
    return 0; // cdigo de retorno al sistema operativo.
}

// EOF: Triang2b.cpp